#include "ugen.h"

struct graph_node_s {
    void *ugen_instance;
    ugen_t *ugen;
    struct graph_node_s *next;
};

typedef struct graph_node_s graph_node_t;


typedef struct {
    int inchannels;
    int outchannels;
    double *inbuf;
    double *outbuf;

    graph_node_t *head;

    ugen_t *ugens;
} graph_t;

graph_t * graph_new(int inchannels, int outchannels);

void graph_delete(graph_t * graph);

graph_node_t * graph_create_node(graph_t * graph, const char *name, ...);

void graph_connect(graph_t * graph, graph_node_t *src, int srcindex,
                   graph_node_t *dst, int dstindex);

void graph_set_out(graph_t * graph, graph_node_t *src, int srcindex, int dstindex);

void graph_put_input(graph_t * graph, double *in);

double *graph_get_next(graph_t * graph);
